
C----------------------------------------------------------------------C
C                                                                      C
C   Global variables common to Metropolis and Swendsen-Wang programs.  C
C                                                                      C
C----------------------------------------------------------------------C

      IMPLICIT NONE

C --- Express stuff
      INTEGER nddata(4), procnum, nprocs
      INTEGER NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      INTEGER procdim(2),proccoord(2)
      INTEGER globsize(2),localsiz(2),orig(2)
      COMMON /PROCGRID/ procnum, nprocs, procdim, proccoord
      COMMON /DATAGRID/ globsize,localsiz,orig

      INTEGER MAX_SIDE, MAX_BUFF, MAX_SITES, MAX_BYTES, MAX_PROCS, MASK
      PARAMETER ( MAX_SIDE  = 256 )
      PARAMETER ( MAX_BUFF  = MAX_SIDE + 2 )
      PARAMETER ( MAX_SITES = MAX_SIDE * MAX_SIDE )
      PARAMETER ( MAX_BYTES = MAX_BUFF * 4 )
      PARAMETER ( MAX_PROCS = 64 )
      PARAMETER ( MASK = 32768 )
	
C --- Parallel stuff
      INTEGER globside,globisiz,globjsiz,globsites
      INTEGER left,right,top,bottom
      INTEGER COMB, EDGE
      PARAMETER ( COMB = 10 )
      PARAMETER ( EDGE = 20 )

      INTEGER spin(0:MAX_SIDE+1,0:MAX_SIDE+1)
      INTEGER isiz, jsiz, sites, accept
      INTEGER isiz_int,jsiz_int,two_isiz_int,two_jsiz_int,imax_int
      REAL volume, beta, p
      
C --- Measurement stuff
      REAL*8  sum_energy, sum_enersq, sum_spins, sum_spinsq, sum_accept
      REAL*8  bin_energy, bin_enersq, bin_spins, bin_spinsq
      REAL*8  avbin_spheat, avbin_spheatsq, avbin_susp, avbin_suspsq
      REAL*8  avbin_enersq, avbin_spinsq
      INTEGER therm_sweeps, sweeps, bin_size, num_bins, 
     &        measurements, ibin

      COMMON /spins/ spin
      COMMON /local_sizes/  isiz,jsiz,sites
      COMMON /global_sizes/ globside,globisiz,globjsiz,globsites,volume
      COMMON /nbors/ left,right,top,bottom
      COMMON /boundaries/ isiz_int,jsiz_int,two_isiz_int,two_jsiz_int,
     &                    imax_int
      COMMON /params/ beta, p
      COMMON /iters/  therm_sweeps, sweeps, bin_size, num_bins, 
     &                measurements, ibin
      COMMON /accpt/  sum_accept, accept
      COMMON /sums/   sum_energy, sum_enersq, sum_spins, sum_spinsq
      COMMON /bins/   bin_energy, bin_enersq, bin_spins, bin_spinsq
      COMMON /avgs/   avbin_spheat, avbin_spheatsq, avbin_susp, 
     &                avbin_suspsq
      COMMON /avsq/   avbin_enersq, avbin_spinsq



